#!/usr/bin/perl -w

# spam4.pl
# Spam Received header filter.
# by Javantea
# Sept 7, 2006

# Usage: spam4.pl [file] [...]
# It will check as many files as you give it.

# Received: from hostname (reverse_dns [ip])
#	by hostname (Name) with protocol id id#
#	for <jvoss@altsci.com>; Fri,  2 Jun 2006 10:58:35 -0700 (PDT)

# Input: spam4.pl spam.msg
# Output: 123.45.67.89

use strict;

sub checkRecvd()
{
	my $data = shift;
	my $hostname = '';
	my $reverse_dns = '';
	my $ip = '';
	if(/from ([^ ]+) \(([^ ]*) ?\[([^\]]*)\]\)/)
	{
		$hostname = $1;
		$reverse_dns = $2;
		$ip = $3;
		#print "from1: $hostname $reverse_dns $ip\n";
	}
	my %ret = ("data",$data, "hostname",$hostname, "reverse_dns",$reverse_dns, "ip",$ip);
	#print $ret{'hostname'} ."\n";
	return %ret;
}

sub checkFile()
{
	my $filename = shift || '/dev/stdin';
	my $recv_tab = 0;
	open(INFILE, $filename) or die("Cannot read $filename.");
	while(<INFILE>)
	{
		if(!$recv_tab && /^Received:/)
		{
			my %retd = &checkRecvd($_);
			if($retd{'ip'} ne '') {
				return $retd{'ip'};
			}
			$recv_tab = 1;
		}
		elsif($recv_tab && /^\t/)
		{
			# recv_tab seems essentially worthless (maybe 1 actual box)
			my %retd = &checkRecvd($_);
			if($retd{'ip'} ne '') {
				return $retd{'ip'};
			}
		}
		#elsif($recv_tab && /^X-Spam-Status:/)
		#{
		#	# This is extra data that we might be interested in.
		#	%retd = &checkSpam($_);
		#	if($retd{'data'} ne '') {
		#		print $retd{'data'} . "\n";
		#		exit 0;
		#	}
		#}
		else
		{
			$recv_tab = 0;
		}
	}
}

if($#ARGV >= 0) {
	my $filename;
	for $filename (@ARGV) {
		my $ip = &checkFile($filename);
		print "$ip\n";
	}
}
else {
	my $ip = &checkFile();
	print "$ip\n";
}

exit 1;
